RELATIONSHIPS_YUML = """
[Products.ZenModel.Device.Device]++hpchassis-[HPChassis]
[HPChassis]++hpsystemboard-[HPSystemBoard]
[HPChassis]++hpcoolingfans-[HPCoolingFan]
[HPChassis]++hppcidevices-[HPPCIDevice]
[HPChassis]++HPprocessors-[HPProcessor]
[HPChassis]++hppowersupplies-[HPServerPowerSupply]
[HPChassis]++hpmemories-[HPMemory]
[HPChassis]++hptemperatures-[HPTemperature]
[HPChassis]++hpmanagementcontroller-[HPManagementController]
[HPChassis]++hpnetworkinterfacecontrollers-[HPNetworkInterfaceController]
[HPChassis]++hpnetworkinterface-[HPNetworkInterface]
[HPChassis]++hplogicaldrives-[HPLogicalDrive]
[HPChassis]++hpphysicaldrives-[HPPhysicalDrive]
[HPChassis]++hposhypervisors-[HPOSHypervisor]
[Products.ZenModel.Device.Device]++-Enclosure_host[HPEnclosure]
[HPEnclosure]++hponboardadmin-hpenclosure[HPOnboardAdmin]
[HPEnclosure]++hpdevicebays-hpenclosure[HPDeviceBay]
[HPEnclosure]++hpthermalsubsystems-hpenclosure[HPThermalSubsystem]
[HPEnclosure]++hppowersubsystems-hpenclosure[HPPowerSubsystem]
[HPEnclosure]++hpinterconnectbays-hpenclosure[HPInterconnectBay]
[HPEnclosure]++hptemperature-hpenclosure[HPTemperatureSensor]
[HPEnclosure]++hptemperatures-hpenclosure[HPTemperatureSensors]
[HPEnclosure]++hpcoolingfans-hpenclosure[HPEnclosureCoolingFan]
[Products.ZenModel.Device.Device]++hpproliantservers-ProliantServer_host[HPProliantServer]
[HPProliantServer]++hpsystemboard-hpproliantserver[HPSystemBoard]
[HPProliantServer]++hpcoolingfans-hpproliantserver[HPCoolingFan]
[HPProliantServer]++hppcidevices-hpproliantserver[HPPCIDevice]
[HPProliantServer]++HPprocessors-hpproliantserver[HPProcessor]
[HPProliantServer]++hppowersupplies-hpproliantserver[HPServerPowerSupply]
[HPProliantServer]++hpmemories-hpproliantserver[HPMemory]
[HPProliantServer]++hptemperatures-hpproliantserver[HPTemperature]
[HPProliantServer]++hpmanagementcontroller-hpproliantserver[HPManagementController]
[HPProliantServer]++hpnetworkinterfacecontrollers-hpproliantserver[HPNetworkInterfaceController]
[HPProliantServer]++hpnetworkinterface-hpproliantserver[HPNetworkInterface]
[HPProliantServer]++hplogicaldrives-hpproliantserver[HPLogicalDrive]
[HPProliantServer]++hpphysicaldrives-hpproliantserver[HPPhysicalDrive]
[HPProliantServer]++hposhypervisors-hpproliantserver[HPOSHypervisor]
"""

CFG = dict(
    name=__name__,

    zProperties={
        'DEFAULTS': {'category': 'ILO'},
        'zILOUserName': {'default': 'Administrator'},
        'zILOPassword': {'type': 'password', 'default': ''},
        'zILOSSLPort': {'type': 'string', 'default': '443'},
    },
    device_classes={
        'Devices/Server/VMware/ESXi': {},
    },
    classes={
        'DEFAULTS': {'base': 'ManagedHardwareObject'},

        # Component Base Types #######################################

        'ManagedObject': {
            'base': zenpacklib.Component,
            'properties': {
                'ilo3': {#'default': True,
                         'grid_display': False,
                         'details_display': False},
                'perfId': {#'default': None,
                           'grid_display': False,
                           'details_display': False},
            },
        },

        'ManagedHardwareObject': {
            'base': zenpacklib.HardwareComponent,
            'properties': {
                'ilo3': {#'default': True,
                         'grid_display': False,
                         'details_display': False},
                'perfId': {#'default': None,
                           'grid_display': False,
                           'details_display': False},
            },
        },

        # Component Types ############################################

        'HPChassis': {
            'label': 'Chassis',
            'monitoring_templates': 'HPChassis',
            'plural_label': 'Chassis',
            'content_width': 150,
            'base': 'ManagedObject',
            'properties': {
                'serverName': {'label': 'Server Name',
                               'grid_display': False,
                               'details_display': False},
                'hwProductName': {'label': 'Product Name',
                                  'grid_display': False},
                'hostOS': {'label': 'Host Operating System',
                           'grid_display': False},
                'sysSerialNo': {'label': 'Serial Number',
                                'index_type': 'field',
                                'index_scope': 'global'},
                'HPDevice': {'label': 'Monitored Host',
                             'label_width': 150,
                             'order': 5,
                             'details_display': False,
                             'api_only': True,
                             'api_backendtype': 'method',
                             'renderer': 'Zenoss.render.default_uid_renderer'},
                'productName': {'label': 'Product',
                                'default': 'N/A'},
                'productId': {'label': 'Id'},
            },
            'relationships': {
                'hpsystemboard': {'grid_display': False},
                'hpcoolingfans': {'grid_display': False},
                'hppowersupplies': {'grid_display': False},
                'hpmemories': {'grid_display': False},
                'hpnetworkinterface': {'grid_display': False},
                'hpnetworkinterfacecontrollers': {'grid_display': False},
                'hposhypervisors': {'grid_display': False},
                'hppcidevices': {'grid_display': False},
                'hpmanagementcontroller': {'grid_display': False},
                'hplogicaldrives': {'grid_display': False},
                'HPprocessors': {'grid_display': False},
                'hpphysicaldrives': {'grid_display': False},
                'hplogicaldrives': {'grid_display': False},
                'hptemperatures': {'grid_display': False},
            },
            'impacts': ['device', 'HPDevice'],
            'impacted_by': ['hpsystemboard', 'hpcoolingfans',
                            'hppowersupplies', 'hpmemories',
                            'hpnetworkinterface',
                            'hpnetworkinterfacecontrollers',
                            'hposhypervisors', 'hppcidevices',
                            'hpmanagementcontroller', 'hplogicaldrives',
                            'HPprocessors', 'hpphysicaldrives',
                            'hplogicaldrives', 'hptemperatures'],

        },

        'HPEnclosure': {
            'label': 'Enclosure',
            'plural_label': 'Enclosures',
            'content_width': 120,
            'monitoring_templates': 'HPEnclosure',
            'base': 'ManagedObject',
            'relationships': {
                'hponboardadmin': {'grid_display': False},
                'hpdevicebays': {'grid_display': False},
                'hpthermalsubsystems': {'grid_display': False},
                'hppowersubsystems': {'grid_display': False},
                'hpinterconnectbays': {'grid_display': False},
                'hptemperature': {'grid_display': False},
                'hpcoolingfans': {'grid_display': False},
                'hptemperatures': {'grid_display': False},
            },
            'impacts': ['device'],
            'impacted_by': ['hponboardadmin', 'hpdevicebays',
                            'hpthermalsubsystems', 'hppowersubsystems',
                            'hpinterconnectbays', 'hptemperature',
                            'hpcoolingfans'],
            'properties': {
                'model': {'label': 'Model',
                          'label_width': 200},
                'serialNumber': {'label': 'Serial Number',
                                 'index_type': 'field',
                                 'index_scope': 'global'},
                'uuid': {'label': 'UUID', },
                'partNumber': {'label': 'Part Number', },
                'firmwareVer': {'label': 'Firmware Version', },
                'status': {'label': 'Status',
                           'api_only': True,
                           'api_backendtype': 'method'},
                'enclosureName': {'label': 'Name',
                                  'grid_display': False,
                                  'details_display': False},
                'address': {'label': 'Address',
                            'grid_display': False},
                'sparePartNum': {'label': 'Spare Part #',
                                 'grid_display': False},
            },
        },

        'HPSystemBoard': {
            # Proliant System Board
            'label': 'System Board',
            'monitoring_templates': 'HPSystemBoard',
            'base': 'ManagedObject',
            'order': 11,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'productName':  {'label': 'Product Name'},
                'sysSerialNo':  {'label': 'Serial #'},
                'romVer':  {'label': 'Rom Version'},
                'redundantROMVersion':  {'label': 'Redundant Rom Version',
                                         'label_width': 150},
                'tpmModule':  {'label': 'TPM Module',
                               'grid_display': True},
                'keyboardType':  {'label': 'Keyboard Type',
                                  'grid_display': False},
                'videoType':  {'label': 'Video Type',
                               'grid_display': False},
                'hoursInService':  {'label': 'Service Hours',
                                    'grid_display': False},
            }
        },

        'HPCoolingFan': {
            # Proliant Cooling Fan
            'label': 'Cooling Fan',
            'monitoring_templates': 'HPCoolingFan',
            'order': 12,
            'base': 'ManagedObject',
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'fanName':  {'label': 'Name',
                             'grid_display': False},
                'locale':  {'label': 'Location'},
                'fanType':  {'label': 'Type'},
                'hotPlug':  {'label': 'HotPlug'},
                'speed':  {'label': 'Speed',
                           'datapoint': 'speed_speed',
                           'api_only': True,
                           'api_backendtype': 'method',
                           'renderer': 'Zenoss.render.hp_percent',
                           'label_width': 80},
                'redundant':  {'label': 'Redundant State',
                               'label_width': 120},
                'condition':  {'label': 'Condition',
                               'api_only': True,
                               'api_backendtype': 'method'},
                'deviceIndex':  {'label': 'Device Index',
                                 'grid_display': False},
                'present':  {'label': 'Present',
                             'grid_display': False},
                'hotPlug':  {'label': 'HotPlug',
                             'grid_display': False},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'sparepartNumber':  {'label': 'Spare Part Number',
                                     'grid_display': False}
            }
        },

        'HPTemperature': {
            # Proliant Temperature Probe
            'label': 'Temperature Probe',
            'monitoring_templates': 'HPTemperature',
            'base': 'ManagedObject',
            'order': 13,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'location':  {'label': 'Location'},
                'tempStatus':  {'label': 'Status',
                                'api_only': True,
                                'api_backendtype': 'method'},
                'index':  {'label': 'Index',
                           'grid_display': False},
                'currentReading':  {'label': 'Current Reading',
                                    'api_only': True,
                                    'api_backendtype': 'method',
                                    'renderer': 'Zenoss.render.hp_temp_celcius'},
                'thresholdType':  {'label': 'Threshold Type',
                                   'grid_display': False},
                'caution':  {'label': 'Caution',
                             'renderer': 'Zenoss.render.hp_temp_celcius',
                             'grid_display': False},
                'critical':  {'label': 'Critical',
                              'renderer': 'Zenoss.render.hp_temp_celcius',
                              'grid_display': False},
            }
        },

        'HPMemory': {
            # Proliant Memory
            'label': 'Memory Slot',
            'monitoring_templates': 'HPMemory',
            'base': 'ManagedObject',
            'order': 14,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'moduleStatus':  {'label': 'Module Status',
                                  'grid_display': False,
                                  'details_display': False},
                'moduleType':  {'label': 'Type'},
                'memorySize':  {'label': 'Size',
                                'renderer': 'Zenoss.render.memory'},
                'frequency':  {'label': 'Frequency',
                               'renderer': 'Zenoss.render.hp_memory_frequency',
                               'label_width': 80},
                'technology':  {'label': 'Technology'},
                'moduleCondition':  {'grid_display': False,
                                     'details_display': False},
                'getmoduleCondition':  {'label': 'Status',
                                        'label_width': 70,
                                        'api_only': True,
                                        'api_backendtype': 'method'},
                'cpuNum':  {'label': 'Cpu Number',
                            'grid_display': False},
                'rank':  {'label': 'Cpu Number',
                          'grid_display': False},
                'moduleNum':  {'label': 'Module Number',
                               'grid_display': False},
            }
        },

        'HPProcessor': {
            # Proliant Processor
            'label': 'Processor',
            'monitoring_templates': 'HPProcessor',
            'base': 'ManagedObject',
            'order': 15,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'grid_display': False,
                             'default': 'N/A'},
                'coreCount':  {'label': 'Cores',
                               'grid_display': True},
                'cacheSizeL1':  {'label': 'L1',
                                 'order': 5.1,
                 'label_width': 50,
                                 'renderer': 'Zenoss.render.hp_cache',
                                 'grid_display': False},
                'cacheSizeL2':  {'label': 'L2',
                                 'order': 5.2,
                 'label_width': 50,
                                 'renderer': 'Zenoss.render.hp_cache',
                                 'grid_display': False},
                'cacheSizeL3':  {'label': 'L3',
                                 'order': 5.3,
                 'label_width': 50,
                                 'renderer': 'Zenoss.render.hp_cache',
                                 'grid_display': False},
                'cpuStatus':  {'label': 'Status',
                               'grid_display': True},
                'cpuidx':  {'label': 'Cpu IDX'},
                'serialIndex':  {'label': 'Serial Index'},
                'location':  {'label': 'Location'},
                'speed':  {'label': 'Speed',
                           'renderer': 'Zenoss.render.cpu_speed'},
                'socket':  {'label': 'Socket'},
                'step':  {'label': 'Step'},
                'hyperThread':  {'label': 'HyperThread'},
                'threadCount':  {'label': 'Thread Count'},
                'coProcessorIndex':  {'label': 'coProcessor Index'},
                'coProcessor':  {'label': 'coProcessor'},
                'coProcessorSpeed':  {'label': 'coProcessor Speed'},
                'coProcessorType':  {'label': 'coProcessor Type'},
                'cacheIndex':  {'label': 'Cache Index'},
                'cacheLevel':  {'label': 'Cache Level'},
                'slot':  {'label': 'Slot'},
                'memoryTech':  {'label': 'memory Tech'},
            }
        },

        'HPServerPowerSupply': {
            # Proliant Server PowerSupply
            'label': 'Power Supply',
            'plural_label': 'Power Supplies',
            'base': 'ManagedObject',
            'monitoring_templates': 'HPServerPowerSupply',
            'order': 16,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'maxPowerSupply':  {'label': 'Max Capacity',
                                    'renderer': 'Zenoss.render.hp_watt_dc',
                                    'label_width': 130},
                'redundant': {'label': 'Redundant State',
                              'label_width': 130},
                'inputStatus':  {'label': 'Input Status',
                                 'api_only': True,
                                 'api_backendtype': 'method'},
                'condition':  {'label': 'Condition',
                               'api_only': True,
                               'api_backendtype': 'method'},
                'serialNumber':  {'label': 'Serial Number',
                                  'grid_display': False},
                'currentPowerSupply':  {'label': 'Current Power Supply',
                                        'grid_display': False,
                                        'datapoint': 'currentPowerSupply_currentPowerSupply',
                                        'renderer': 'Zenoss.render.hp_watt_dc'},
                'powerSupplyBay': {'label': 'Power Supply Bay',
                                   'grid_display': False},
                'powerSupplyPresent': {'label': 'Power Supply Present',
                                       'grid_display': False},
                'model': {'label': 'Model',
                          'grid_display': False},
                'hotPlug': {'label': 'Hot Plug',
                            'grid_display': False},
                'sparePartNumber':  {'label': 'Spare Part Number',
                                     'grid_display': False},
                'errorCondition': {'label': 'Error Condition',
                                   'grid_display': False},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'powerIndex':  {'label': 'Power Index',
                                'grid_display': False},
            }
        },

        'HPPCIDevice': {
            # Proliant PCI Device
            'label': 'PCI Device',
            'monitoring_templates': 'HPPCIDevice',
            'order': 17,
            'impacts': ['hpchassis'],
            'base': 'ManagedHardwareObject',
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'pciBusIndex':  {'label': 'PCI Bus',
                                 'label_width': 70},
                'pciDeviceIndex':  {'label': 'Device Number'},
                'pciSlotType':  {'label': 'Slot Type'},
                'pciSlotWidth':  {'label': 'Slot Width'},
                'pciSlotBoardName':  {'label': 'Board Name'},
                'pciPhysicalSlot':  {'label': 'Physical Slot',
                                     'grid_display': False},
                'classCode':  {'label': 'Class Code',
                               'grid_display': False},
                'vendorID':  {'label': 'Vendor ID',
                              'grid_display': False},
                'pciDeviceID':  {'label': 'PCI Device ID',
                                 'grid_display': False},
                'subsystemID':  {'label': 'Subsystem ID',
                                 'grid_display': False},
                'subsystemVendorID':  {'label': 'Subsystem Vendor ID',
                                       'grid_display': False},
                'num':  {'label': 'Num',
                         #'default': None,
                         'grid_display': False},
            }
        },

        'HPManagementController': {
            # Proliant Management Controller
            'label': 'Management Controller',
            'monitoring_templates': 'HPManagementController',
            'order': 18,
            'base': 'ManagedHardwareObject',
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'serialNumber':  {'label': 'Serial Number',
                                  'label_width': 98},
                'firmware':  {'label': 'Firmware Version'},
                'licenseType':  {'label': 'Active License Type',
                                 'label_width': 148},
                'interfaceStatus':  {'label': 'Interface Status',
                                     'api_only': True,
                                     'api_backendtype': 'method'},
                'mpStatus':  {'grid_display': False,
                              'details_display': False},
                'getMPStatusString':  {'label': 'Status',
                                       'api_only': True,
                                       'api_backendtype': 'method',
                                       'grid_display': False},
                'swithSecurity':  {'label': 'swithSecurity',
                                   'grid_display': False},
                'insightAlertStatus':  {'label': 'Insight Alert Status',
                                        'grid_display': False},
                'insightPendingAlerts':  {'label': 'Insight Pending Alerts',
                                          'grid_display': False},
                'firmwareDate':  {'label': 'Firmware Date',
                                  'grid_display': False},
                'managementProcessor':  {'label': 'Management Processor',
                                         'grid_display': False},
                'ipv4Address':  {'label': 'ipv4 Address',
                                 'grid_display': False},
                'url':  {'label': 'url',
                         'grid_display': False},
                'hardwareVersion':  {'label': 'Hardware Version',
                                     'grid_display': False},
            }
        },

        'HPPhysicalDrive': {
            # Proliant Physical Drive
            'label': 'Physical Drive',
            'monitoring_templates': 'HPPhysicalDrive',
            'order': 19,
            'impacts': ['hpchassis'],
            'base': 'ManagedObject',
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'productId':  {'label': 'productId',
                               'grid_display': False},
                'driveType':  {'label': 'Type',
                               'label_width': 75,
                               'grid_display': False},
                'driveFirmware':  {'label': 'Firmware'},
                'driveCapacity':  {'label': 'Capacity',
                                   'label_width': 80,
                                   'renderer': 'Zenoss.render.bytesString'},
                'driveSpeed':  {'label': 'Rotational Speed',
                                'grid_display': False},
                'driveStatus':  {'label': 'Status',
                                 'api_only': True,
                                 'api_backendtype': 'method',
                                 'label_width': 80},
                'location':  {'label': 'Location',
                              'grid_display': False},
                'manufacturer':  {'label': 'Manufacturer',
                                  'grid_display': False,
#                                  'default': None},
                                  'default': ''},

                'driveModel':  {'label': 'Model',
                                'grid_display': False},
                'bayIndex':  {'label': 'Index',
                              'grid_display': False},
                'uidState':  {'label': 'uidState',
                              'grid_display': False},
                'NegotiatedDataWidth':  {'label': 'Negotiated Data Width',
                                         'grid_display': False},
                'NegotiatedSpeed':  {'label': 'Negotiated Speed',
                                     'grid_display': False},
                'DriveConfiguration':  {'label': 'Configuration',
                                        'grid_display': False},
                'Name':  {'label': 'Name',
                          'grid_display': False},
                'DriveRotationalSpeed':  {'label': 'Drive Rotational Speed',
                                          'grid_display': False},
                'DeviceID':  {'label': 'Device ID',
                              'grid_display': False},
                'BlockSize':  {'label': 'BlockSize',
                               'renderer': 'Zenoss.render.hp_bytes_string',
                               'grid_display': False},
                'serialNumber':  {'label': 'Serial Number',
                                  'grid_display': False},
            }
        },
        'HPLogicalDrive': {
            # Proliant Logical Drive
            'label': 'Logical Drive',
            'monitoring_templates': 'HPLogicalDrive',
            'order': 19.1,
            'base': 'ManagedObject',
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A',
                             'grid_display': False},
                'PackageRedundancy':  {'label': 'Package Redundancy',
                                       'label_width': 200,
                                       'grid_display': False},
                'stripeSize':  {'label': 'Strip Size',
                                'renderer': 'Zenoss.render.hp_kbytes_string',
                                'grid_display': True},
                'BlockSize':  {'label': 'Block Size',
                               'grid_display': False},
                'driveStatus':  {'label': 'Status',
                                 'api_only': True,
                                 'api_backendtype': 'method',
                                 'grid_display': True},
                'driveCapacity':  {'label': 'Capacity',
                                   'grid_display': True,
                                   'renderer': 'Zenoss.render.bytesString'},
                'driveIndex':  {'label': 'Index'},
                'logicPerfIndex':  {'label': 'Logic Perf Index'},
                'DataRedundancy':  {'label': 'Data Redundancy'},
                'ElementName':  {'label': 'Element Name'},
                'Name':  {'label': 'Name'},
            }
        },
        'HPNetworkInterfaceController': {
            # Proliant Network Interface Controller
            'label': 'NIC',
            'monitoring_templates': 'HPNetworkInterfaceController',
            'order': 20,
            'base': 'ManagedObject',
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'nicId':  {'label': 'Nic ID'},
                'portName':  {'label': 'Port Name'},
                'nicType':  {'label': 'Nic Type'},
                'macID':  {'label': 'Mac ID'},
            }
        },
        'HPNetworkInterface': {
            # Proliant Network Interface
            'label': 'Network Interface',
            'monitoring_templates': 'HPNetworkInterface',
            'base': 'ManagedHardwareObject',
            'order': 20.1,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'DEFAULTS': {'default': 'N/A', 'grid_display': False},
                'HealthState':  {'label': 'Health State'},
                'MaxSpeed':  {'label': 'Max Speed'},
                'LinkTechnology':  {'label': 'Link Technology'},
                'Speed':  {'label': 'Speed', 'grid_display': True},
                'Capabilities':  {'label': 'Capabilities'},
                'PortNumber':  {'label': 'Port Number'},
                'AutoSense':  {'label': 'AutoSense'},
                'Description':  {'label': 'Description'},
                'PortType':  {'label': 'Port Type', 'grid_display': True},
                'ElementName':  {'label': 'Element Name'},
                'FullDuplex':  {'label': 'Full Duplex', 'grid_display': True},
                'Name':  {'label': 'Name'},
                'BytesReceived':  {'label': 'BytesReceived'},
                'SingleCollisionFrames':  {'label': 'SingleCollisionFrames'},
                'AlignmentErrors':  {'label': 'AlignmentErrors'},
                'InternalMACReceiveErrors':  {'label': 'InternalMACReceiveErrors'},
                'BytesTransmitted':  {'label': 'BytesTransmitted'},
                'PacketsReceived':  {'label': 'PacketsReceived'},
                'InternalMACTransmittedErrors':  {'label': 'InternalMACTransmittedErrors'},
                'ExcessiveCollisions':  {'label': 'ExcessiveCollisions'},
                'FCSErrors':  {'label': 'FCSErrors'},
                'MultipleCollisionFrames':  {'label': 'MultipleCollisionFrames'},
                'MTU':  {'label': 'MTU',
                         'renderer': 'Zenoss.render.hp_bytes_string'},
                'CurrentSpeed':  {'label': 'Current Speed'},
            }
        },
        'HPOSHypervisor': {
            # Proliant OS Hypervisor
            'label': 'OS Hypervisor',
            'monitoring_templates': 'HPOSHypervisor',
            'base': 'ManagedHardwareObject',
            'order': 21,
            'impacts': ['hpchassis'],
            'relationships': {
                'hpproliantserver': {'grid_display': False,
                                     'details_display': False},
            },
            'properties': {
                'osType':  {'label': 'OS Type',
                            'label_width': 65},
                'version':  {'label': 'OS Version',
                             'label_width': 80},
                'hostOSDetail':  {'label': 'OS Description',
                                  'grid_display': False,
                                  'label_width': 120},
                'romVer':  {'label': 'romVer',
                            'grid_display': False},
                'hostOS':  {'label': 'Host Operating System',
                            'grid_display': False},
                'hwProductName':  {'label': 'Product Name',
                                   'grid_display': False},
                'productId':  {'label': 'Product ID',
                               'grid_display': True},
                'redundantROMVersion':  {'label': 'Redundant ROM Version',
                                         'grid_display': False},
                'hoursInService':  {'label': 'Service Hours',
                                    'grid_display': False},
                'tpmModule':  {'label': 'TPM Module',
                               'label_width': 68,
                               'grid_display': True},
                'serverName':  {'label': 'serverName',
                                'label_width': 75,
                                'grid_display': True},
                'machineId':  {'label': 'Machine ID',
                               'label_width': 65,
                               'grid_display': True},
                'keyboardType':  {'label': 'Keyboard Type',
                                  'grid_display': False},
                'videoType':  {'label': 'Video Type',
                               'grid_display': False},
                'telnetStatus':  {'label': 'Telnet Status',
                                  'default': 'N/A',
                                  'grid_display': False},
            }
        },
        'HPThermalSubsystem': {
            # Thermal Subsystem
            'label': 'Thermal Subsystem',
            'monitoring_templates': 'HPThermalSubsystem',
            'base': 'ManagedHardwareObject',
            'impacts': ['hpenclosure'],
            'order': 22,
            'properties': {
                'partNumber':  {'label': 'Part Number'},
                'sparepartNumber':  {'label': 'Spare Part Number'},
                'condition':  {'label': 'Status',
                               'api_only': True,
                               'api_backendtype': 'method'},
                'location':  {'label': 'Location',
                              'grid_display': False},
                'redundant':  {'label': 'Redundant',
                               'grid_display': False},
                'presence':  {'label': 'Presence',
                              'grid_display': False},
                'fanIndex':  {'label': 'Fan Index',
                              'grid_display': False},
            }
        },
        'HPTemperatureSensor': {
            # Temperature Sensors
            'label': 'Temperature Sensor',
            'plural_label': 'Temperature Sensors',
            'base': 'ManagedObject',
            'monitoring_templates': 'HPTemperatureSensors',
            'order': 23,
            'impacts': ['hpenclosure'],
            'properties': {
                'location':  {'label': 'Location',
                              'label_width': 200},
                'currentReading':  {'label': 'Current Reading',
                                    'renderer': 'Zenoss.render.hp_temp_celcius',
                                    'grid_display': True},
                'trap':  {'label': 'Trap',
                          'renderer': 'Zenoss.render.hp_temp_celcius',
                          'grid_display': False},
                'status':  {'label': 'Status',
                            'grid_display': True,
                            'api_only': True,
                            'api_backendtype': 'method'},
                'type':  {'label': 'Type',
                          'grid_display': False},
                'tempIndex':  {'label': 'Temperature Index',
                               'grid_display': False},
            }
        },
        'HPPowerSubsystem': {
            # Power Subsystem
            'label': 'Power Subsystem',
            'monitoring_templates': 'HPPowerSubsystem',
            'base': 'ManagedObject',
            'order': 24,
            'impacts': ['hpenclosure'],
            'properties': {
                'maxPowerSupply':  {'label': 'Output Capacity',
                                    'renderer': 'Zenoss.render.hp_watt_dc'},
                'inputStatus':  {'label': 'Input Status',
                                 'api_only': True,
                                 'api_backendtype': 'method'},
                'condition':  {'label': 'Status',
                               'api_only': True,
                               'api_backendtype': 'method'},
                'serialNumber':  {'label': 'Serial Number',
                                  'grid_display': False},
                'currentPowerSupply':  {'label': 'Current Capacity',
                                        'grid_display': False,
                                        'datapoint': 'currentPowerSupply_currentPowerSupply',
                                        'renderer': 'Zenoss.render.hp_watt_dc'},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'sparePartNumber':  {'label': 'sparePartNumber',
                                     'grid_display': False},
                'powerIndex':  {'label': 'Power Index',
                                'grid_display': False},
                'presence':  {'label': 'Presence',
                              'grid_display': False},
            }
        },
        'HPInterconnectBay': {
            # Interconnect Bay
            'label': 'Interconnect Bay',
            'base': 'ManagedObject',
            'monitoring_templates': 'HPInterconnectBay',
            'order': 25,
            'impacts': ['hpenclosure'],
            'properties': {
                'Model':  {'label': 'Product Name',
                           'label_width': 200},
                'serialNumber':  {'label': 'Serial Number'},
                'present':  {'label': 'Present',
                             'grid_display': False},
                'location':  {'label': 'Location',
                              'grid_display': False},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'sparePartNum':  {'label': 'Spare Part Number',
                                  'grid_display': False},
                'switchIndex':  {'label': 'Switch Index',
                                 'grid_display': False},
            }
        },
        'HPOnboardAdmin': {
            # Enclosure Onboard Administrator
            'label': 'Onboard Administrator',
            'base': 'ManagedObject',
            'monitoring_templates': 'HPOnboardAdmin',
            'order': 26,
            'impacts': ['hpenclosure'],
            'properties': {
                'location':  {'label': 'Bay Number'},
                'serialNumber':  {'label': 'Serial Number'},
                'role':  {'label': 'Role'},
                'presence':  {'label': 'Presence'},
                'oaStatus':  {'label': 'Status',
                            'grid_display': True,
                            'api_only': True,
                            'api_backendtype': 'method'},
                'Uuid':  {'label': 'UUID',
                          'grid_display': False},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'sparePartNumber':  {'label': 'Spare Part Number',
                                     'grid_display': False},
                'redundant':  {'label': 'Redundant',
                               'grid_display': False},
                'OAIndex':  {'label': 'OAIndex',
                             'grid_display': False},
            }
        },
        'HPDeviceBay': {
            # Enclosure Onboard Administrator
            'label': 'Device Bay',
            'base': 'ManagedObject',
            'monitoring_templates': 'HPDeviceBay',
            'order': 27,
            'impacts': ['hpenclosure', 'HPDevice'],
            'properties': {
                'productId':  {'label': 'Product Id',
                               'order': 5.1,
                               'label_width': 120},
                'partNumber':  {'label': 'Part Number',
                'label_width': 71,
                                'order': 5.5},
                'serviceTag':  {'label': 'Service Tag',
                                'order': 5.6,
                'label_width': 75,
                                'index_type': 'field',
                                'index_scope': 'global'},
                'PoweredState':  {'label': 'Powered State',
                                  'api_only': True,
                                  'api_backendtype': 'method',
                                  'order': 5.8},
                'serverStatus':  {'label': 'Server Status',
                                  'api_only': True,
                                  'api_backendtype': 'method',
                                  'order': 5.9,
                                  'label_width': 60},
                'HPDevice':   {'label': 'Device',
                               'order': 5,
                               'api_only': True,
                               'api_backendtype': 'method',
                               'details_display': False,
                               'renderer': 'Zenoss.render.default_uid_renderer'},
                'bladeWattsMax':  {'label': 'Blade Watts Max',
                                   'grid_display': False},
                'biosRevision':  {'label': 'Bios Revision',
                                  'grid_display': False},
                'bladeWattsAvg':  {'label': 'Blade Watts Average',
                                   'grid_display': False},
                'slotnumber':  {'label': 'Slot Number',
                                'grid_display': False},
                'bladeWattsMin':  {'label': 'Blade Watts Min',
                                   'grid_display': False},
                'sparePartNumber':  {'label': 'Spare Part Number',
                                     'grid_display': False},
                'firmwareversion':  {'label': 'Firmware Version',
                                     'grid_display': False},
                'bladeDeviceLink':  {'label': 'Blade Device Link',
                                     'grid_display': False},
            }
        },
        'HPEnclosureCoolingFan': {
            # Proliant Cooling Fan
            'label': 'Cooling Fan',
            'monitoring_templates': 'HPEnclosureCoolingFan',
            'base': 'ManagedObject',
            'order': 28,
            'impacts': ['hpenclosure'],
            'properties': {
                'DEFAULTS': {'default': 'N/A'},
                'location':  {'label': 'Location'},
                'redundant':  {'label': 'Redundant State',
                               'label_width': 120},
                'condition':  {'label': 'Condition',
                               'api_only': True,
                               'api_backendtype': 'method'},
                'partNumber':  {'label': 'Part Number',
                                'grid_display': False},
                'sparepartNumber':  {'label': 'Spare Part Number',
                                     'grid_display': False},
                'presence':  {'label': 'Presence',
                              'grid_display': False},
            }
        },

        # Legacy Components  ( Remove extra relationships if we remove these)
        # These only exist to migrate at this point
        # add the relationships grid_display:false to stop zpl from warning...
        'HPProliantServer': {'base': 'ManagedHardwareObject',
                             'relationships': { 'hpsystemboard': {'grid_display': False},
                                                'hpcoolingfans': {'grid_display': False},
                                                'hppowersupplies': {'grid_display': False},
                                                'hpmemories': {'grid_display': False},
                                                'hpnetworkinterface': {'grid_display': False},
                                                'hpnetworkinterfacecontrollers': {'grid_display': False},
                                                'hposhypervisors': {'grid_display': False},
                                                'hppcidevices': {'grid_display': False},
                                                'hpmanagementcontroller': {'grid_display': False},
                                                'hplogicaldrives': {'grid_display': False},
                                                'HPprocessors': {'grid_display': False},
                                                'hpphysicaldrives': {'grid_display': False},
                                                'hplogicaldrives': {'grid_display': False},
                                                'hptemperatures': {'grid_display': False},
                                              },
                              },
        'HPTemperatureSensors': {'base': zenpacklib.Component},
    },

    class_relationships=zenpacklib.relationships_from_yuml(RELATIONSHIPS_YUML),
)
